//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C434218014B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C434218014B.cm

//## begin module%3C434218014B.cp preserve=no
//## end module%3C434218014B.cp

//## Module: Weight%3C434218014B; Package body
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/Weight.cxx

//## begin module%3C434218014B.additionalIncludes preserve=no
//## end module%3C434218014B.additionalIncludes

//## begin module%3C434218014B.includes preserve=yes
#include <xsTypes.h>
//## end module%3C434218014B.includes

// SpectralData
#include <XSModel/Data/SpectralData.h>
// Model
#include <XSModel/Model/Model.h>
// Weight
#include <XSModel/GlobalContainer/Weight.h>


//## begin module%3C434218014B.declarations preserve=yes
#include <XSModel/Data/BackCorr/Background.h>
#include <XSModel/Data/Detector/Response.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSContainer.h>
#include <XSsymbol.h>
#include <sstream>
//## end module%3C434218014B.declarations

//## begin module%3C434218014B.additionalDeclarations preserve=yes
//## end module%3C434218014B.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
        Weight::~Weight()
        {
                // body for abstract dtor. 
        }
    //## end XSContainer%3E42929A0210.initialDeclarations

    // Class XSContainer::Weight::ArrayInitializationError 

    Weight::ArrayInitializationError::ArrayInitializationError (size_t num)
      //## begin XSContainer::Weight::ArrayInitializationError::ArrayInitializationError%3C599F270169.hasinit preserve=yes
        : RedAlert(" initializing statistic workspace arrays:\n ")  
      //## end XSContainer::Weight::ArrayInitializationError::ArrayInitializationError%3C599F270169.hasinit
      //## begin XSContainer::Weight::ArrayInitializationError::ArrayInitializationError%3C599F270169.initialization preserve=yes
      //## end XSContainer::Weight::ArrayInitializationError::ArrayInitializationError%3C599F270169.initialization
    {
      //## begin XSContainer::Weight::ArrayInitializationError::ArrayInitializationError%3C599F270169.body preserve=yes
        std::ostringstream message;
        message << " Statistic calculation found spectrum number " << num << " array incorrect size ";
        reportAndExit(message.str(),-5);
      //## end XSContainer::Weight::ArrayInitializationError::ArrayInitializationError%3C599F270169.body
    }


    // Class XSContainer::Weight 


    Weight::Weight (const string& name)
      //## begin XSContainer::Weight::Weight%437388B2000C.hasinit preserve=yes
      : m_name(name)
      //## end XSContainer::Weight::Weight%437388B2000C.hasinit
      //## begin XSContainer::Weight::Weight%437388B2000C.initialization preserve=yes
      //## end XSContainer::Weight::Weight%437388B2000C.initialization
    {
      //## begin XSContainer::Weight::Weight%437388B2000C.body preserve=yes
      //## end XSContainer::Weight::Weight%437388B2000C.body
    }



    //## Other Operations (implementation)
    void Weight::dataVariance (const Model& model, ArrayContainer& variance) const
    {
      //## begin XSContainer::Weight::dataVariance%3C43407E00E2.body preserve=yes
        
       // add model systematic error estimate to the variance.

       Real msyst = XSContainer::models->modelSystematicError();
       ArrayContainer::const_iterator ma = model.foldedModel().begin();
       ArrayContainer::const_iterator maEnd = model.foldedModel().end();

       for ( ; ma != maEnd ; ++ma)
       {
             size_t index = ma->first;
             SpectralData* s = model.spectrum(index);
             const std::valarray<size_t>& IN = s->indirectNotice();
             if ( variance[index].size() != IN.size()) 
             {
                     throw ArrayInitializationError(index);
             }        
             if (!model.foldedModelError().empty() && model.foldedModelError(index).size())
             {
                     variance[index] += model.foldedModelError(index)[IN]; 
             }
             if (msyst > SMALL)
             {
                     RealArray f (model.foldedModel(index)[IN]);
                     variance[index] += msyst*msyst*f*f;       
             }
       }
      //## end XSContainer::Weight::dataVariance%3C43407E00E2.body
    }

    void Weight::varianceDeriv (const Model& model, ArrayContainer& dv)
    {
      //## begin XSContainer::Weight::varianceDeriv%3C55A0BC038C.body preserve=yes
       Real msyst = XSContainer::models->modelSystematicError();
       if ( msyst >= SMALL)
       {
             std::map<size_t,Response*>::const_iterator ma = model.detector().begin();
             std::map<size_t,Response*>::const_iterator maEnd = model.detector().end();
             for ( ; ma != maEnd ; ++ma)
             {
                     size_t index = ma->first;
                     SpectralData* s = model.spectrum(index);
                     const std::valarray<size_t>& IN = s->indirectNotice();
                     RealArray& varDeriv = dv[index];
                     if ( varDeriv.size() != IN.size()) 
                     {
                             varDeriv.resize(IN.size(),0.);
                     }        
                     varDeriv += msyst*msyst*model.foldedModel(index)[IN];
             }
       }
      //## end XSContainer::Weight::varianceDeriv%3C55A0BC038C.body
    }

    // Class XSContainer::StandardWeight 

    StandardWeight::StandardWeight ()
      //## begin XSContainer::StandardWeight::StandardWeight%43738AF50179.hasinit preserve=yes
      : Weight("standard")
      //## end XSContainer::StandardWeight::StandardWeight%43738AF50179.hasinit
      //## begin XSContainer::StandardWeight::StandardWeight%43738AF50179.initialization preserve=yes
      //## end XSContainer::StandardWeight::StandardWeight%43738AF50179.initialization
    {
      //## begin XSContainer::StandardWeight::StandardWeight%43738AF50179.body preserve=yes
      //## end XSContainer::StandardWeight::StandardWeight%43738AF50179.body
    }


    StandardWeight::~StandardWeight()
    {
      //## begin XSContainer::StandardWeight::~StandardWeight%3C4348DB02CA_dest.body preserve=yes
      //## end XSContainer::StandardWeight::~StandardWeight%3C4348DB02CA_dest.body
    }



    //## Other Operations (implementation)
    void StandardWeight::operator () (SpectralData& spectrum, const RealArray& norm) const
    {
      //## begin XSContainer::StandardWeight::operator()%3C4348FB01F7.body preserve=yes
       spectrum.setVariance(spectrum.rawVariance());
      //## end XSContainer::StandardWeight::operator()%3C4348FB01F7.body
    }

    void StandardWeight::dataVariance (const Model& model, ArrayContainer& variance) const
    {
      //## begin XSContainer::StandardWeight::dataVariance%3C4348FE01B1.body preserve=yes
       // do nothing unless systematics are required.      

       Weight::dataVariance(model,variance);
      //## end XSContainer::StandardWeight::dataVariance%3C4348FE01B1.body
    }

    StandardWeight* StandardWeight::clone () const
    {
      //## begin XSContainer::StandardWeight::clone%3C84F97C01F3.body preserve=yes
      //## end XSContainer::StandardWeight::clone%3C84F97C01F3.body

      return new StandardWeight(*this);
    }

    // Class XSContainer::ModelWeight 

    ModelWeight::ModelWeight ()
      //## begin XSContainer::ModelWeight::ModelWeight%43738AE60283.hasinit preserve=yes
      : Weight("model")
      //## end XSContainer::ModelWeight::ModelWeight%43738AE60283.hasinit
      //## begin XSContainer::ModelWeight::ModelWeight%43738AE60283.initialization preserve=yes
      //## end XSContainer::ModelWeight::ModelWeight%43738AE60283.initialization
    {
      //## begin XSContainer::ModelWeight::ModelWeight%43738AE60283.body preserve=yes
      //## end XSContainer::ModelWeight::ModelWeight%43738AE60283.body
    }


    ModelWeight::~ModelWeight()
    {
      //## begin XSContainer::ModelWeight::~ModelWeight%3C4341BA0176_dest.body preserve=yes
      //## end XSContainer::ModelWeight::~ModelWeight%3C4341BA0176_dest.body
    }



    //## Other Operations (implementation)
    void ModelWeight::dataVariance (const Model& model, ArrayContainer& variance) const
    {
      //## begin XSContainer::ModelWeight::dataVariance%3C4348080278.body preserve=yes
  Weight::dataVariance(model,variance);
  // model weight stuff goes here...
  
        
  // add model systematic error estimate to the variance.
  std::map<size_t,Response*>::const_iterator ma = model.detector().begin();
  std::map<size_t,Response*>::const_iterator maEnd = model.detector().end();
  
  for ( ; ma != maEnd ; ++ma)
  {
        size_t index = ma->first;
        SpectralData* s = ma->second->source();
        const std::valarray<size_t>& IN = s->indirectNotice();
        if (variance[index].size() != IN.size()) 
        {
                throw ArrayInitializationError(index);
        }
        RealArray areaT = s->areaScale()[IN]*s->exposureTime();
        RealArray f    = model.foldedModel(index)[IN];
        
        variance[index] += f / areaT ;
  }  
      //## end XSContainer::ModelWeight::dataVariance%3C4348080278.body
    }

    void ModelWeight::varianceDeriv (const Model& model, ArrayContainer& dv)
    {
      //## begin XSContainer::ModelWeight::varianceDeriv%3C55AD16024E.body preserve=yes
       Weight::varianceDeriv(model,dv);

       std::map<size_t,Response*>::const_iterator i = model.detector().begin();
       std::map<size_t,Response*>::const_iterator iEnd = model.detector().end();

       for ( ; i != iEnd ; ++i)
       {
          size_t index = i->first;
          SpectralData* s  = model.spectrum(index);
          const std::valarray<size_t>& IN = s->indirectNotice();
          RealArray& varDeriv = dv[index];
          if (varDeriv.size() != IN.size())
          {
             varDeriv.resize(IN.size());       
          }       
          varDeriv += 1./(2.*s->areaScale()[IN]*s->exposureTime());
       }
      //## end XSContainer::ModelWeight::varianceDeriv%3C55AD16024E.body
    }

    void ModelWeight::operator () (SpectralData& spectrum, const RealArray& norm) const
    {
      //## begin XSContainer::ModelWeight::operator()%3C5AA92E020C.body preserve=yes
       // Treat as standard weighting here.  Model values will be applied
       // during fitting stage.
       spectrum.setVariance(spectrum.rawVariance());
      //## end XSContainer::ModelWeight::operator()%3C5AA92E020C.body
    }

    ModelWeight* ModelWeight::clone () const
    {
      //## begin XSContainer::ModelWeight::clone%3C84F99600E3.body preserve=yes
      //## end XSContainer::ModelWeight::clone%3C84F99600E3.body

      return new ModelWeight(*this);
    }

    // Class XSContainer::GehrelsWeight 

    GehrelsWeight::GehrelsWeight ()
      //## begin XSContainer::GehrelsWeight::GehrelsWeight%43738AC20230.hasinit preserve=yes
      : Weight("gehrels")
      //## end XSContainer::GehrelsWeight::GehrelsWeight%43738AC20230.hasinit
      //## begin XSContainer::GehrelsWeight::GehrelsWeight%43738AC20230.initialization preserve=yes
      //## end XSContainer::GehrelsWeight::GehrelsWeight%43738AC20230.initialization
    {
      //## begin XSContainer::GehrelsWeight::GehrelsWeight%43738AC20230.body preserve=yes
      //## end XSContainer::GehrelsWeight::GehrelsWeight%43738AC20230.body
    }


    GehrelsWeight::~GehrelsWeight()
    {
      //## begin XSContainer::GehrelsWeight::~GehrelsWeight%3C4341A80377_dest.body preserve=yes
      //## end XSContainer::GehrelsWeight::~GehrelsWeight%3C4341A80377_dest.body
    }



    //## Other Operations (implementation)
    void GehrelsWeight::operator () (SpectralData& spectrum, const RealArray& norm) const
    {
      //## begin XSContainer::GehrelsWeight::operator()%3C43440E00F9.body preserve=yes
        const RealArray& rate = spectrum.spectrum();
        size_t n = rate.size();
        RealArray gwVar(0.,n);
        static const Real OFFSET(0.75);
        
        // checking for zeros in exposure and area is performed by ]
        // DataSet::setDescription.
        
        // Doing these valarray arithmetic operations in a more tortured
        // manner to get around g++4.0.x runtime crashes with -O2 optimization.
        for (int i=0; i<n; ++i)
        {
           Real norm_i = norm[i];
           gwVar[i] = (sqrt(norm_i*rate[i] + OFFSET) + 1.0)/norm_i;
        }
        gwVar *= gwVar;
        spectrum.setVariance(gwVar);
      //## end XSContainer::GehrelsWeight::operator()%3C43440E00F9.body
    }

    void GehrelsWeight::dataVariance (const Model& model, ArrayContainer& variance) const
    {
      //## begin XSContainer::GehrelsWeight::dataVariance%3C4348000009.body preserve=yes
  return Weight::dataVariance(model,variance);
      //## end XSContainer::GehrelsWeight::dataVariance%3C4348000009.body
    }

    GehrelsWeight* GehrelsWeight::clone () const
    {
      //## begin XSContainer::GehrelsWeight::clone%3C8506190355.body preserve=yes
      //## end XSContainer::GehrelsWeight::clone%3C8506190355.body

      return new GehrelsWeight(*this);
    }

    // Class XSContainer::ChurazovWeight 

    ChurazovWeight::ChurazovWeight ()
      //## begin XSContainer::ChurazovWeight::ChurazovWeight%43738A1401FD.hasinit preserve=yes
      : Weight("churazov")
      //## end XSContainer::ChurazovWeight::ChurazovWeight%43738A1401FD.hasinit
      //## begin XSContainer::ChurazovWeight::ChurazovWeight%43738A1401FD.initialization preserve=yes
      //## end XSContainer::ChurazovWeight::ChurazovWeight%43738A1401FD.initialization
    {
      //## begin XSContainer::ChurazovWeight::ChurazovWeight%43738A1401FD.body preserve=yes
      //## end XSContainer::ChurazovWeight::ChurazovWeight%43738A1401FD.body
    }


    ChurazovWeight::~ChurazovWeight()
    {
      //## begin XSContainer::ChurazovWeight::~ChurazovWeight%3C43418E01CE_dest.body preserve=yes
      //## end XSContainer::ChurazovWeight::~ChurazovWeight%3C43418E01CE_dest.body
    }



    //## Other Operations (implementation)
    void ChurazovWeight::operator () (SpectralData& spectrum, const RealArray& norm) const
    {
      //## begin XSContainer::ChurazovWeight::operator()%3C43441D028E.body preserve=yes
        
        const RealArray& rate = spectrum.spectrum();
        int n = rate.size();
        RealArray cwVar(0.,n);
        static const Real MAXCOUNTS = 20.;
        for (int l = 0; l < n; ++l)
        {
                Real current = rate[l]*norm[l];
                bool terminate = current >= MAXCOUNTS;
                int lower = l;
                int upper = l;
                size_t bins  = 1;
                while (!terminate)
                {
                        --lower;       
                        ++upper;
                        if (lower >=0 )
                        {
                                ++bins;
                                current += rate[lower]*norm[lower];      
                        }
                        if (upper < n)
                        {
                                ++bins;
                                current += rate[upper]*norm[upper];
                        }
                        terminate = ( (lower < 0 && upper >= n) || current >= MAXCOUNTS);
                }
                
                cwVar[l] = current / (bins*norm[l]*norm[l]);
        }
             
        spectrum.setVariance(cwVar);
        
        
      //## end XSContainer::ChurazovWeight::operator()%3C43441D028E.body
    }

    void ChurazovWeight::dataVariance (const Model& model, ArrayContainer& variance) const
    {
      //## begin XSContainer::ChurazovWeight::dataVariance%3C4347F401FC.body preserve=yes
  return Weight::dataVariance(model,variance);
      //## end XSContainer::ChurazovWeight::dataVariance%3C4347F401FC.body
    }

    ChurazovWeight* ChurazovWeight::clone () const
    {
      //## begin XSContainer::ChurazovWeight::clone%3C84F9BC0106.body preserve=yes
      //## end XSContainer::ChurazovWeight::clone%3C84F9BC0106.body

      return new ChurazovWeight(*this);
    }

} // namespace XSContainer

//## begin module%3C434218014B.epilog preserve=yes
//## end module%3C434218014B.epilog
